package dev.shadowsoffire.apotheosis.village.fletching.arrows;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.util.BlockUtil;
import java.util.UUID;
import net.minecraft.core.BlockPos;
import net.minecraft.core.particles.ParticleOptions;
import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.nbt.Tag;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.network.protocol.Packet;
import net.minecraft.network.protocol.game.ClientGamePacketListener;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.sounds.SoundEvents;
import net.minecraft.util.Mth;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.projectile.AbstractArrow;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.level.ClipContext;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.phys.AABB;
import net.minecraft.world.phys.BlockHitResult;
import net.minecraft.world.phys.HitResult;
import net.minecraft.world.phys.Vec3;
import net.minecraft.world.phys.shapes.VoxelShape;
import net.minecraftforge.entity.IEntityAdditionalSpawnData;
import net.minecraftforge.network.NetworkHooks;

public class MiningArrowEntity extends AbstractArrow implements IEntityAdditionalSpawnData {
  protected int blocksBroken = 0;
  
  protected UUID playerId = null;
  
  protected ItemStack breakerItem = ItemStack.f_41583_;
  
  protected Type type = Type.IRON;
  
  public MiningArrowEntity(EntityType<? extends AbstractArrow> t, Level world) {
    super(t, world);
    this.f_36705_ = AbstractArrow.Pickup.DISALLOWED;
  }
  
  public MiningArrowEntity(Level world) {
    this((EntityType<? extends AbstractArrow>)Apoth.Entities.MINING_ARROW.get(), world);
  }
  
  public MiningArrowEntity(LivingEntity shooter, Level world, ItemStack breakerItem, Type type) {
    super((EntityType)Apoth.Entities.MINING_ARROW.get(), shooter, world);
    this.breakerItem = breakerItem;
    this.f_36705_ = AbstractArrow.Pickup.DISALLOWED;
    this.type = type;
    this.playerId = shooter.m_20148_();
  }
  
  public MiningArrowEntity(Level world, double x, double y, double z, ItemStack breakerItem, Type type) {
    super((EntityType)Apoth.Entities.MINING_ARROW.get(), x, y, z, world);
    this.f_36705_ = AbstractArrow.Pickup.DISALLOWED;
    this.breakerItem = breakerItem;
    this.type = type;
  }
  
  protected ItemStack m_7941_() {
    return ItemStack.f_41583_;
  }
  
  public Packet<ClientGamePacketListener> m_5654_() {
    return NetworkHooks.getEntitySpawningPacket((Entity)this);
  }
  
  public void m_8119_() {
    if (!(m_9236_()).f_46443_)
      m_20115_(6, m_142038_()); 
    m_6075_();
    boolean noClip = m_36797_();
    Vec3 motion = m_20184_();
    if (this.f_19860_ == 0.0F && this.f_19859_ == 0.0F) {
      double d0 = motion.m_165924_();
      m_146922_((float)(Mth.m_14136_(motion.f_82479_, motion.f_82481_) * 57.2957763671875D));
      m_146926_((float)(Mth.m_14136_(motion.f_82480_, d0) * 57.2957763671875D));
      this.f_19859_ = m_146908_();
      this.f_19860_ = m_146909_();
    } 
    BlockPos blockpos = m_20183_();
    BlockState blockstate = m_9236_().m_8055_(blockpos);
    if (!blockstate.m_60795_() && !noClip) {
      VoxelShape voxelshape = blockstate.m_60812_((BlockGetter)m_9236_(), blockpos);
      if (!voxelshape.m_83281_()) {
        Vec3 vec31 = m_20182_();
        for (AABB aabb : voxelshape.m_83299_()) {
          if (aabb.m_82338_(blockpos).m_82390_(vec31)) {
            this.f_36703_ = true;
            break;
          } 
        } 
      } 
    } 
    if (this.f_36706_ > 0)
      this.f_36706_--; 
    if (m_20070_() || blockstate.m_60713_(Blocks.f_152499_))
      m_20095_(); 
    if (this.f_36703_) {
      m_146870_();
    } else {
      this.f_36704_ = 0;
      Vec3 pos = m_20182_();
      Vec3 posNextTick = pos.m_82549_(motion);
      int iterations = 0;
      while (!(m_9236_()).f_46443_ && m_6084_()) {
        BlockHitResult blockHitResult = m_9236_().m_45547_(new ClipContext(pos, posNextTick, ClipContext.Block.COLLIDER, ClipContext.Fluid.NONE, (Entity)this));
        if (blockHitResult.m_6662_() == HitResult.Type.MISS)
          break; 
        if (blockHitResult.m_6662_() == HitResult.Type.BLOCK)
          m_6532_((HitResult)blockHitResult); 
        if (iterations++ > 10)
          break; 
      } 
      motion = m_20184_();
      double dX = motion.f_82479_;
      double dY = motion.f_82480_;
      double dZ = motion.f_82481_;
      if (m_36792_())
        for (int i = 0; i < 4; i++)
          m_9236_().m_7106_((ParticleOptions)ParticleTypes.f_123797_, m_20185_() + dX * i / 4.0D, m_20186_() + dY * i / 4.0D, m_20189_() + dZ * i / 4.0D, -dX, -dY + 0.2D, -dZ);  
      double nextX = m_20185_() + dX;
      double nextY = m_20186_() + dY;
      double nextZ = m_20189_() + dZ;
      double hDist = motion.m_165924_();
      if (noClip) {
        m_146922_((float)(Mth.m_14136_(-dX, -dZ) * 57.2957763671875D));
      } else {
        m_146922_((float)(Mth.m_14136_(dX, dZ) * 57.2957763671875D));
      } 
      m_146926_((float)(Mth.m_14136_(dY, hDist) * 57.2957763671875D));
      m_146926_(m_37273_(this.f_19860_, m_146909_()));
      m_146922_(m_37273_(this.f_19859_, m_146908_()));
      float f = 0.99F;
      if (m_20069_()) {
        for (int j = 0; j < 4; j++)
          m_9236_().m_7106_((ParticleOptions)ParticleTypes.f_123795_, nextX - dX * 0.25D, nextY - dY * 0.25D, nextZ - dZ * 0.25D, dX, dY, dZ); 
        f = m_6882_();
      } 
      m_20256_(motion.m_82490_(f));
      if (!m_20068_() && !noClip) {
        Vec3 vec34 = m_20184_();
        m_20334_(vec34.f_82479_, vec34.f_82480_ - 0.05000000074505806D, vec34.f_82481_);
      } 
      m_6034_(nextX, nextY, nextZ);
    } 
  }
  
  protected void m_8060_(BlockHitResult res) {
    breakBlock(res.m_82425_());
  }
  
  public boolean m_20068_() {
    return false;
  }
  
  public void m_7380_(CompoundTag compound) {
    super.m_7380_(compound);
    compound.m_128405_("blocks_broken", this.blocksBroken);
    if (this.playerId != null)
      compound.m_128362_("player_id", this.playerId); 
    compound.m_128365_("breaker_item", (Tag)this.breakerItem.serializeNBT());
    compound.m_128344_("arrow_type", (byte)this.type.ordinal());
  }
  
  public void m_7378_(CompoundTag compound) {
    super.m_7378_(compound);
    this.blocksBroken = compound.m_128451_("blocks_broken");
    if (compound.m_128441_("player_id"))
      this.playerId = compound.m_128342_("player_id"); 
    this.breakerItem = ItemStack.m_41712_(compound.m_128469_("breaker_item"));
    this.type = Type.values()[compound.m_128445_("arrow_type")];
  }
  
  public void writeSpawnData(FriendlyByteBuf buf) {
    buf.writeByte(this.type.ordinal());
  }
  
  public void readSpawnData(FriendlyByteBuf buf) {
    this.type = Type.values()[buf.readByte()];
  }
  
  protected void breakBlock(BlockPos pos) {
    if (!(m_9236_()).f_46443_ && !m_9236_().m_8055_(pos).m_60795_())
      if (BlockUtil.breakExtraBlock((ServerLevel)m_9236_(), pos, this.breakerItem, this.playerId)) {
        if (++this.blocksBroken >= 12)
          m_146870_(); 
      } else {
        m_5496_(SoundEvents.f_11669_, 1.0F, 1.5F / (this.f_19796_.m_188501_() * 0.2F + 0.9F));
        m_146870_();
      }  
  }
}
